#!/usr/bin/perl
use lib 'lib';
use WWW::Dict::Leo::Org;
use Data::Dumper;

# configure access to dict.leo.org
my $leo = new WWW::Dict::Leo::Org(
                                  -UserAgent      => 'IE 19',
                                  -Debug          => 0,
                                  -SpellTolerance => 'on',
                                  -Morphology     => 'standard',
                                  -CharTolerance  => 'relaxed',
                                  -Language       => @ARGV[1]
                                 );

# fetch matches
my @result = $leo->translate(@ARGV[3]);

my $output = "[";
my $lastTitle = "";
if (@result && $leo->lines() >= 1) {
  foreach my $category (@result) {
    my $lastChar = substr $output, -1;
    #if ($lastChar eq "}") {
    #  $output .= ",";
    #}
    #$output .= "\n{\"title\": \"".$category->{title}."\", \"icon\":\"font-awesome:caret-down\"}";

    my @categoryData = $category->{data};

    foreach my $match (@{$category->{data}}) {
      my $lastChar = substr $output, -1;
      if ($lastChar eq "}") {
        $output .= ",";
      }
      my $left = $match->{left};
      $left =~ s/\"/\\"/g;
      my $right = $match->{right};
      $right =~ s/\"/\\"/g;
      if (($left eq '') || ($left eq ' ')) {
        $left = $right;
      }
      my $title = $category->{title};
      $title =~ s/\"/\\"/g;
      if (@ARGV[2] eq "true") {
        my $tmp = $left;
        $left = $right;
        $right = $tmp;
      }
      if ($title eq $lastTitle) {
        $title = "";
      } else {
        $lastTitle = $title;
      }
      $output .= "\n{\"title\": \"".$left."\", \"subtitle\": \"".$right."\", \"icon\":\"".@ARGV[0]."\", \"label\": \"".$title."\", \"alwaysShowsSubtitle\":\"true\", \"url\":\"http://dict.leo.org/".@ARGV[0]."de/index_de.html\#/search=".@ARGV[3]."\"}";
    }
  }
}
else {
}
$output .= "]";

print $output;
