// LaunchBar Action Script

function runWithString(argument) {
  if (Action.preferences.language == undefined)
    Action.preferences.language = "en";

  // Backwards compatibility...
  if (Action.preferences.language.endsWith("de"))
    Action.preferences.language = Action.preferences.language.replace("de", "");

  LaunchBar.debugLog(argument);
  var directionLanguage = Action.preferences.language;
  var reverse = "false";
  if (LaunchBar.options.commandKey) {
    directionLanguage = Action.preferences.language + "2de";
    reverse = "true";
  }
  if (LaunchBar.options.shiftKey)
    directionLanguage = "de2" + Action.preferences.language;
  var searchURL = "http://dict.leo.org/"+Action.preferences.language+"de/index_de.html#/search=" + encodeURI(argument);
  try {
    var result = LaunchBar.execute('leo.pl', Action.preferences.language, directionLanguage, reverse, encodeURI(argument));
    LaunchBar.debugLog(result);
    resultObject = JSON.parse(result);
    LaunchBar.debugLog(resultObject);

    if (resultObject.length > 0) {
      return resultObject;
    }
    else
    LaunchBar.openURL(searchURL);
  } catch(ex) {
    LaunchBar.debugLog(ex);
    LaunchBar.debugLog(result);
    LaunchBar.openURL(searchURL);
  }
}

function run() {
  return [
    {title: "Deutsch - Englisch", subtitle: "English - Deutsch", icon: "en.png", action: "setLanguage", actionArgument: "en"},
    {title: "Deutsch - Spanisch", subtitle: "Spanisch - Deutsch", icon: "es.png", action: "setLanguage", actionArgument: "es"},
    {title: "Deutsch - Französisch", subtitle: "Französisch - Deutsch", icon: "fr.png", action: "setLanguage", actionArgument: "fr"},
    {title: "Deutsch - Italienisch", subtitle: "Italienisch - Deutsch", icon: "it.png", action: "setLanguage", actionArgument: "it"},
    {title: "Deutsch - Chinesisch", subtitle: "Chinesisch - Deutsch", icon: "ch.png", action: "setLanguage", actionArgument: "ch"},
    {title: "Deutsch - Russisch", subtitle: "Russisch - Deutsch", icon: "ru.png", action: "setLanguage", actionArgument: "ru"},
    {title: "Deutsch - Polnisch", subtitle: "Polnisch - Deutsch", icon: "pl.png", action: "setLanguage", actionArgument: "pl"}
  ];
}

function setLanguage(language) {
  Action.preferences.language = language;
  return [{title: "Sprache gesetzt.", subtitle: "Benutze Leertaste auf der Action um zu suchen...", icon: "font-awesome:check-circle"}];
}
